//
// BioArray Software Environment (BASE) - homepage http://base.thep.lu.se/
// Copyright (C) 2002, 2003  Bjrn Samuelsson, Carl Troein
//
// This file is part of BASE.
//
// BASE is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// BASE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#ifndef MYPLUGIN_MICROARRAY_POINT_HH
#define MYPLUGIN_MICROARRAY_POINT_HH

#include <cstdlib>

struct microarr_point
{
  int index;
  double R, G, ratio, intens;
  
  microarr_point(int i, double r, double g):
    index(i), R(r), G(g),
    ratio((R>0 && G>0) ? R/G : -1.),
    intens((R>0 && G>0) ? sqrt(R*G) : -1.){}
  double maxF(){return std::max(R, G);}
  double minF(){return std::min(R, G);}
};

template <double microarr_point:: *member>
struct microarr_point_ptr_m_less: 
  public std::binary_function<microarr_point*, microarr_point*, bool>
{
  bool operator()(microarr_point *a, microarr_point *b)
  {return a->*member < b->*member;}
};

template <double (microarr_point:: *member)()>
struct microarr_point_ptr_less: 
  public std::binary_function<microarr_point*, microarr_point*, bool>
{
  bool operator()(microarr_point *a, microarr_point *b)
  {return (a->*member)() < (b->*member)();}
};

#endif
